summaryrefslogtreecommitdiff
path: root/gettext-tools/tests/format-pascal-2
diff options
context:
space:
mode:
authorBruno Haible <bruno@clisp.org>2003-02-14 14:36:30 +0000
committerBruno Haible <bruno@clisp.org>2009-06-23 12:09:43 +0200
commit108b00904d4fbbbbdd15aa6accd7ed7f4323d91e (patch)
treedf5c9a50c002b6661fb346e3965ad0cd7e0199bc /gettext-tools/tests/format-pascal-2
parent6b7e1f459ced689447034c9f34fcdfed850257b1 (diff)
downloadgettext-108b00904d4fbbbbdd15aa6accd7ed7f4323d91e.tar.gz
Move tests/format-pascal-2 to gettext-tools/tests/format-pascal-2.
Diffstat (limited to 'gettext-tools/tests/format-pascal-2')
-rwxr-xr-xgettext-tools/tests/format-pascal-2133
1 files changed, 133 insertions, 0 deletions
diff --git a/gettext-tools/tests/format-pascal-2 b/gettext-tools/tests/format-pascal-2
new file mode 100755
index 000000000..d6a53d8cb
--- /dev/null
+++ b/gettext-tools/tests/format-pascal-2
@@ -0,0 +1,133 @@
+#! /bin/sh
+
+# Test checking of Object Pascal format strings.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles f-op-2.data"
+cat <<\EOF > f-op-2.data
+# Valid: %% doesn't count
+msgid "abc%%def"
+msgstr "xyz"
+# Invalid: invalid msgstr
+msgid "abc%%def"
+msgstr "xyz%"
+# Valid: same arguments
+msgid "abc%s%gdef"
+msgstr "xyz%s%g"
+# Valid: same arguments, with different widths
+msgid "abc%2sdef"
+msgstr "xyz%3s"
+# Valid: same arguments but in numbered syntax
+msgid "abc%s%gdef"
+msgstr "xyz%0:s%1:g"
+# Valid: permutation
+msgid "abc%s%g%cdef"
+msgstr "xyz%2:c%1:g%0:s"
+# Invalid: too few arguments
+msgid "abc%1:xdef%0:s"
+msgstr "xyz%0:s"
+# Invalid: too few arguments
+msgid "abc%sdef%x"
+msgstr "xyz%s"
+# Invalid: too many arguments
+msgid "abc%xdef"
+msgstr "xyz%xvw%p"
+# Valid: same numbered arguments, with different widths
+msgid "abc%1:5s%0:4s"
+msgstr "xyz%1:4s%0:5s"
+# Invalid: missing argument
+msgid "abc%1:sdef%0:x"
+msgstr "xyz%0:x"
+# Invalid: missing argument
+msgid "abc%0:sdef%1:x"
+msgstr "xyz%1:x"
+# Invalid: added argument
+msgid "abc%0:xdef"
+msgstr "xyz%0:xvw%1:p"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%f"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%g"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%n"
+# Valid: type compatibility
+msgid "abc%e"
+msgstr "xyz%m"
+# Invalid: type incompatibility
+msgid "abc%d"
+msgstr "xyz%e"
+# Invalid: type incompatibility
+msgid "abc%d"
+msgstr "xyz%s"
+# Invalid: type incompatibility
+msgid "abc%d"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%d"
+msgstr "xyz%x"
+# Invalid: type incompatibility
+msgid "abc%e"
+msgstr "xyz%s"
+# Invalid: type incompatibility
+msgid "abc%e"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%e"
+msgstr "xyz%x"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%p"
+# Invalid: type incompatibility
+msgid "abc%s"
+msgstr "xyz%x"
+# Invalid: type incompatibility
+msgid "abc%p"
+msgstr "xyz%x"
+# Invalid: type incompatibility for width
+msgid "abc%g%*g"
+msgstr "xyz%*g%g"
+EOF
+
+: ${MSGFMT=msgfmt}
+n=0
+while read comment; do
+ read msgid_line
+ read msgstr_line
+ n=`expr $n + 1`
+ tmpfiles="$tmpfiles f-op-2-$n.po f-op-2-$n.mo"
+ cat <<EOF > f-op-2-$n.po
+#, object-pascal-format
+${msgid_line}
+${msgstr_line}
+EOF
+ fail=
+ if echo "$comment" | grep 'Valid:' > /dev/null; then
+ if ${MSGFMT} --check-format -o f-op-2-$n.mo f-op-2-$n.po; then
+ :
+ else
+ fail=yes
+ fi
+ else
+ ${MSGFMT} --check-format -o f-op-2-$n.mo f-op-2-$n.po 2> /dev/null
+ if test $? = 1; then
+ :
+ else
+ fail=yes
+ fi
+ fi
+ if test -n "$fail"; then
+ echo "Format string checking error:" 1>&2
+ cat f-op-2-$n.po 1>&2
+ exit 1
+ fi
+ rm -f f-op-2-$n.po f-op-2-$n.mo
+done < f-op-2.data
+
+rm -fr $tmpfiles
+
+exit 0